/* --------------------------------------------------------
   ASYQ[  vC[R[h
   ፇ

                                     2004/7/15
                                         S.Mio
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "game.h"


/* ----------------------------------------------------- */
/* }bvL^Ǘ */
typedef struct {
    t_mapinfo mapinfo;
    int attackcost;
    int refcount;
} t_maplog;
t_maplog maplog[MAP_WIDTH][MAP_HEIGHT];

/* URXgǗ */
/* 0RXg̍ɕ */
#define COSTQUE_LIMIT  (16)
typedef struct {
    t_pos pos;
    int attackcost;
} t_mapcost;
t_mapcost costquebody[COSTQUE_LIMIT];
t_mapcost *costque[COSTQUE_LIMIT];


/* ----------------------------------------------------- */
/* tF[YǗ */
#define PHASE_MOVE      (0)
#define PHASE_SEARCH    (1)
#define PHASE_SEEDGET   (2)
#define PHASE_ATTACK    (3)
#define PHASE_MAGICEXEC (4)
#define PHASE_LIMIT     (5)

static int phase;
void set_phase(int no)
{
    phase = no;
}

int get_phase(void)
{
    return phase;
}


/* ----------------------------------------------------- */
char *phasestr[] = {
    "PHASE_MOVE",
    "PHASE_SEARCH",
    "PHASE_SEEDGET",
    "PHASE_ATTACK",
    "PHASE_MAGICEXEC",
};

char *magicstr[] = {
    "MAGICSEED_FIRE",
    "MAGICSEED_WATER",
    "MAGICSEED_WOOD",
    "MAGICSEED_WIND",
    "MAGICSEED_EARTH",
};

char *cmdstr[] = {
    "CMD_MOVE",
    "CMD_MAGIC",
    "CMD_GETSEED",
    "CMD_SEARCH",
};



/* ----------------------------------------------------- */
/* }bv֘A */
static t_pos difpos[]   = {{0, -1}, {1, 0}, {0, 1}, {-1, 0}};

/* L[̏ */
void maplog_queinit(void)
{
    int i;

    for (i = 0; i < COSTQUE_LIMIT; i++) {
        costquebody[i].pos.x = -1;
        costquebody[i].pos.y = -1;
        costquebody[i].attackcost = -1;
        costque[i] = NULL;
    }
}

/* maplog̏ */
void maplog_init(void)
{
    int x, y;

    for (y = 0; y < MAP_HEIGHT; y++) {
        for (x = 0; x < MAP_WIDTH; x++) {
            maplog[x][y].attackcost = 0;
            maplog[x][y].refcount = 0;
        }
    }
    maplog_queinit();
}

/* L[p̐Vvf𓾂 */
t_mapcost *maplog_newcostitem(void)
{
    int i;
    
    for (i = 0; i < COSTQUE_LIMIT; i++) {
        if ((costquebody[i].pos.x == -1) &&
            (costquebody[i].pos.y == -1))  {
            return &costquebody[i];
        }
    }
    return NULL;
}

/* L[瓯n_̗vf폜 */
void maplog_removecostque(int x, int y)
{
    int i, j;
    
    for (i = 0; i < COSTQUE_LIMIT; i++) {
        if (costque[i] == NULL)
            break;
        if ((costque[i]->pos.x == x) &&
            (costque[i]->pos.y == y)){
            costque[i]->pos.x = -1;
            costque[i]->pos.y = -1;
            for (j = i; j < COSTQUE_LIMIT - 1; j++) {
                costque[j] = costque[j + 1];
                if (costque[j] == NULL)
                    break;
            }
            costque[COSTQUE_LIMIT - 1] = NULL;
            break;
        }
    }
}

/* L[ɃRXgݒ */
void maplog_setcostque(int x, int y, int cost)
{
    t_mapcost *destmapcost;
    int i, j;

    /* n_̂̂ */
    maplog_removecostque(x, y);
    destmapcost = NULL;
    for (i = 0; i < COSTQUE_LIMIT; i++) {
        if (costque[i] == NULL) {
            destmapcost = maplog_newcostitem();
            break;
        }
        if (costque[i]->attackcost <= cost) {
            destmapcost = maplog_newcostitem();
            if (destmapcost == NULL)
                destmapcost = costque[COSTQUE_LIMIT - 1];
            for (j = COSTQUE_LIMIT - 1; j > i; j--) {
                if (costque[j - 1] == NULL)
                    continue;
                costque[j] = costque[j - 1];
            }
            break;
        }
    }
    
    if (cost <= 0)
        return;

    /* l */
    if (destmapcost != NULL) {
        destmapcost->pos.x = x;
        destmapcost->pos.y = y;
        destmapcost->attackcost = cost;
        costque[i] = destmapcost;
    }
}

/* maplogx,yn_փRXgݒ */
void maplog_setcost(int x, int y, int cost)
{
    maplog[x][y].attackcost = cost;
    maplog_setcostque(x, y, cost);
}

/* maplogx,yn_փRXg */
void maplog_addcost(int x, int y, int cost)
{
    maplog[x][y].attackcost += cost;
    maplog_setcostque(x, y, maplog[x][y].attackcost);
}

/* sƂ/ƂJEg */
void maplog_addref(int x, int y)
{
    maplog[x][y].refcount++;
}

/* RXg̍|Cg𓾂 */
t_pos *maplog_getcost(int pos)
{
    if (costque[pos] == NULL)
        return NULL;

    return &costque[pos]->pos;
}

/* 2_Ԃ̋𑪂 */
int maplog_distance(int x1, int y1, int x2, int y2)
{
    int dx, dy, d;

    dx = abs(x1 - x2);
    dy = abs(y1 - y2);

    d = ((dx < dy) ? dx : dy) / 2;
    return  dx + dy - d;
}

/* T𓾂 */
int maplog_getsearchdir(int x, int y)
{
    int movecost[MOVE_LIMIT];
    t_pos *attackpos;
    int i, dx, dy, dir;

    for (i = 0; i < MOVE_LIMIT; i++)
        movecost[i] = 0;

    /* xƂ̓RXg𑝂₷ */
    for (i = 0; i < MOVE_LIMIT; i++) {
        dx = x + difpos[i].x;
        dy = y + difpos[i].y;
        if ((dx < 0) || (dy < 0) || (dx >= MAP_WIDTH) || (dy >= MAP_HEIGHT))
            continue;
        movecost[i] += maplog[dx][dy].refcount;
    }

    /* UΏۂ̃|CgƏdȂȂRXg炷 */
    for (i = 0; i < COSTQUE_LIMIT; i++) {
        attackpos = maplog_getcost(i);
        if (attackpos == NULL) {
            break;
        }
        if (attackpos->x == x) {
            if (attackpos->y < y) {
                movecost[MOVE_UP] -= 5;
            } else {
                movecost[MOVE_DOWN] -= 5;
            }
        }
        if (attackpos->y == y) {
            if (attackpos->x < x) {
                movecost[MOVE_LEFT] -= 5;
            } else {
                movecost[MOVE_RIGHT] -= 5;
            }
        }
    }
    
    /* RXgႢ̂Ƃ */
    dir = 0;
    for (i = 1; i < MOVE_LIMIT; i++) {
        if (movecost[dir] > movecost[i])
            dir = i;
    }
    return dir;
}

/* URXgXVC͂ɎU炵Ă */
void maplog_areadiffusion(void)
{
    int i, x, y, dx, dy;

    for (y = 0; y < MAP_HEIGHT; y++) {
        for (x = 0; x < MAP_WIDTH; x++) {
            if (maplog[x][y].attackcost > 0)
                maplog[x][y].attackcost--;
            maplog_setcostque(x, y, maplog[x][y].attackcost);
            for (i = 0; i < MOVE_LIMIT; i++) {
                dx = x + difpos[i].x;
                dy = y + difpos[i].y;
                if ((dx < 0) || (dy < 0) || (dx >= MAP_WIDTH) || (dy >= MAP_HEIGHT))
                    continue;
                maplog_setcostque(dx, dy, 
                    (maplog[x][y].attackcost + maplog[dx][dy].attackcost) / 2);
            }
        }
    }
}


/* ----------------------------------------------------- */
/* ړ */
int cmd_move(t_playerinfo *player, t_cmd *cmd, t_mapitem *mapitem)
{
    int movecost[MOVE_LIMIT];
    int x, y, dx, dy, i, movepos, nextphase;
    t_pos *attackpos;

    x = player->pos.x;
    y = player->pos.y;
    attackpos = maplog_getcost(0);
    for (i = 0; i < MOVE_LIMIT; i++)
        movecost[i] = 0;
    for (i = 0; i < MOVE_LIMIT; i++) {
        if (player->movearea[i] == false)
            continue;
        
        /* ĂȂƂD悳邽߁C*/
        /* QƂ񐔂RXg */
        dx = difpos[i].x;
        dy = difpos[i].y;
        movecost[i] -= maplog[x + dx][y + dy].refcount;

        /* URXg̍֐i܂邽            */
        /* ő勗+URXg`vC[̋𑫂 */
        if (attackpos != NULL) {
            movecost[i] += maplog_distance(0, 0, MAP_WIDTH, MAP_HEIGHT) - 
                           maplog_distance(x, y, attackpos->x, attackpos->y);
        }
    }
    
    /* ΂RXĝI */
    movepos = rand() % MOVE_LIMIT;
    for (i = 0; i < MOVE_LIMIT; i++) {
        if (player->movearea[movepos])
            break;
        movepos++;
        if (movepos >= MOVE_LIMIT)
            movepos = 0;
    }
    for (i = 0; i < MOVE_LIMIT; i++) {
        if (!player->movearea[i])
            continue;
        if (movecost[i] > movecost[movepos]) {
            movepos = i;
        }
    }
    cmd->type = CMD_MOVE;
    cmd->move = movepos;
    //printf("movecost: %d %d %d %d\n", movecost[0], movecost[1], movecost[2], movecost[3]);
    //printf("cmd->move %d\n", cmd->move);
    
    /* ̍s */
    nextphase = PHASE_SEARCH;
    if (player->seedcount) {
        /* vf̂Ȃ疂@ */
        /* ΂΂ōUD */
        if (player->magicseed_typecount[MAGICSEED_FIRE]) {
            nextphase = PHASE_ATTACK;
        } else {
            nextphase = PHASE_MAGICEXEC;
        }
    }
    return nextphase;
}

/* T[` */
int cmd_search(t_playerinfo *player, t_cmd *cmd, t_mapitem *mapitem)
{
    /* ͂𒲂ׂ */
    cmd->type = CMD_SEARCH;
    /* ׂ͈ */
    cmd->count = 1;
    return PHASE_SEEDGET;
}

/* @̗vf𓾂 */
int cmd_getmagicseed(t_playerinfo *player, t_cmd *cmd, t_mapitem *mapitem)
{
    int i, seedattr, nextphase;

    /* vfȂ̂Ȃړ */
    if ((mapitem->magicseed_typecount[MAGICSEED_FIRE] == 0) && 
        (mapitem->magicseed_typecount[MAGICSEED_WIND] == 0)) {
        return cmd_move(player, cmd, mapitem);
    }

    /* ̒n_̂Ȃőق𓾂 */
    if (mapitem->magicseed_typecount[MAGICSEED_FIRE] >
        mapitem->magicseed_typecount[MAGICSEED_WIND]) {
        seedattr = MAGICSEED_FIRE;
    } else {
        seedattr = MAGICSEED_WIND;
    }
    cmd->type = CMD_GETSEED;
    cmd->magictype = seedattr;
    cmd->count = mapitem->magicseed_typecount[seedattr];
    //printf("player->seedcount %d\n", player->seedcount);
    //printf("mapitem->seedcount %d\n", mapitem->seedcount);
    //printf("get magictype %s count %d\n", magicstr[cmd->magictype], cmd->count);

    /* phase߂ */
    nextphase = PHASE_SEEDGET;
    /* łɂςׂ */
    if ((player->seedcount + cmd->count) >= PLAYERSEED_LIMIT) {
        /* ΂΂ōUD */
        if (player->magicseed_typecount[MAGICSEED_FIRE]) {
            nextphase = PHASE_ATTACK;
        } else {
            nextphase = PHASE_MAGICEXEC;
        }
    }
    
    /* ̒n_̗vfsĂړ */
    if ((mapitem->seedcount - cmd->count) <= 0) {
        nextphase = PHASE_MOVE;
    }
    return nextphase;
}


/* U */
int cmd_magicattack(t_playerinfo *player, t_cmd *cmd, t_mapitem *mapitem)
{
    t_pos *attackpos;

    cmd->type = CMD_MAGIC;
    cmd->magictype = MAGICSEED_FIRE;
    if (player->magicseed_typecount[MAGICSEED_FIRE] >= 2)
        cmd->magiccost = 2;
    else
        cmd->magiccost = 1;

    /* ^킵n_ɂԂ */
    cmd->pos.x = rand() % MAP_WIDTH;
    cmd->pos.y = rand() % MAP_HEIGHT;
    attackpos = maplog_getcost(0);
    if (attackpos != NULL) {
        cmd->pos.x = attackpos->x;
        cmd->pos.y = attackpos->y;
    }

    //printf("cmd->magictype    %s\n", magicstr[MAGICSEED_FIRE]);
    //printf("cmd->magiccost    %d\n", cmd->magiccost);
    //printf("player->seedcount %d\n", player->seedcount);
    //printf("player->typecount %d\n", player->magicseed_typecount[MAGICSEED_FIRE]);
    //printf("pos x:%d y:%d\n", cmd->pos.x, cmd->pos.y);
    
    /* ͈ړ */
    return PHASE_MOVE;
}

/* @̎s */
int cmd_magicexec(t_playerinfo *player, t_cmd *cmd, t_mapitem *mapitem)
{
    t_pos *attackpos;
    int i, seedattr, nextphase;

    /* Ƃ̂s */
    /* ̃[`ł͖@̎ނ肵Ă܂ */
    seedattr = 0;
    for (i = 0; i < MAGICSEED_LIMIT; i++) {
        if (player->magicseed_typecount[seedattr] < player->magicseed_typecount[i]) {
            seedattr = i;
        }
    }
    cmd->type = CMD_MAGIC;
    cmd->magictype = seedattr;
    if (player->magicseed_typecount[seedattr] >= 2)
        cmd->magiccost = 2;
    else
        cmd->magiccost = 1;
    //printf("cmd->magictype    %s\n", magicstr[cmd->magictype]);
    //printf("cmd->magiccost    %d\n", cmd->magiccost);
    //printf("player->seedcount %d\n", player->seedcount);
    //printf("player->typecount %d\n", player->magicseed_typecount[seedattr]);

    if (seedattr == MAGICSEED_WIND) {
        /* ƂĒTĂȂƂ낪T */
        cmd->move = maplog_getsearchdir(player->pos.x, player->pos.y);
    } else if (seedattr == MAGICSEED_EARTH) {
        /* ^킵n_̎͂ɕǂ */
        cmd->pos.x = rand() % MAP_WIDTH;
        cmd->pos.y = rand() % MAP_HEIGHT;
        attackpos = maplog_getcost(0);
        if (attackpos != NULL) {
            cmd->pos.x = attackpos->x;
            cmd->pos.y = attackpos->y;
            maplog_setcost(cmd->pos.x, cmd->pos.y, 0);
        }
        //printf("pos x:%d y:%d\n", cmd->pos.x, cmd->pos.y);
    }

    /* ͈ړ */
    return PHASE_MOVE;
}

typedef int (*t_func)(t_playerinfo *player, t_cmd *cmd, t_mapitem *mapitem);
t_func cmdlist[PHASE_LIMIT] = {
    cmd_move,
    cmd_search,
    cmd_getmagicseed,
    cmd_magicattack,
    cmd_magicexec,
};


/* ----------------------------------------------------- */
/* R[h */
void wizard_init(t_initinfo *item)
{
    int x, y;
    
    maplog_init();
    strcpy(item->name, "player(ፇ^Cv)");
    item->pos.x = 5;
    item->pos.y = 5;
    
    set_phase(PHASE_SEEDGET);
    
    /* Q[JnCG͂̃GAɂ̂ */
    /* ̍Un_RXg߂Ă */
    for (y = 0; y < MAP_HEIGHT; y++) {
        for (x = MAP_WIDTH / 2; x < MAP_WIDTH; x++) {
            maplog_setcost(x, y, MAP_WIDTH / 2);
        }
    }
}

/* ^[̍sI */
void wizard_turnselect(t_playerinfo *player, t_cmd *cmd, t_mapitem *mapitem)
{
    /* }bvf[^̍XV */
    memcpy(&maplog[player->pos.x][player->pos.y].mapinfo.mapitem, 
        mapitem, sizeof(t_mapinfo));
    maplog_addref(player->pos.x, player->pos.y);
    
    /* URXgXV */
    /* ͂ɎU炵Ă */
    maplog_areadiffusion();

    /* Ƃ0 */
    maplog_setcost(player->pos.x, player->pos.y, 0);

    /* sƎphase߂ */
    phase = cmdlist[phase](player, cmd, mapitem);
    //printf("cmd: %s\n", cmdstr[cmd->type]);
    //printf("magic: %d\n", cmd->magictype);
    //printf("phase: %s\n", phasestr[phase]);
}

/* s̎s */
void wizard_turnresult(t_playerinfo *player, t_result *result)
{
    int x, y, hitx, hity, i;

    if (result->type == CMD_TURNSKIP) {
        /* ̃^[̓XLbv */
        return;
    }
    
    if (result->iscmdexec == false) {
        //printf("s\n");
        return;
    }
    //printf("\n");
    
    if ((result->type == CMD_SEARCH) ||
        ((result->type == CMD_MAGIC) &&
         (result->magictype == MAGICSEED_WIND))) {
        if (result->count) {
            for (i = 0; i < result->count; i++) {
                /* Tʒu */
                x = result->hitinfo[i].pos.x;
                y = result->hitinfo[i].pos.y;
                /* vC[RXgグ */
                if (result->mapinfo[i].isplayer) {
                    maplog_addcost(x, y, 10);
                }
                memcpy(&maplog[x][y].mapinfo, 
                    &result->mapinfo[i], sizeof(t_mapinfo));
                maplog_addref(player->pos.x, player->pos.y);
            }
        }
    }

    if ((result->type == CMD_MAGIC) &&
         (result->magictype == MAGICSEED_FIRE)) {
         
         if (result->hitcount) {
            for (i = 0; i < result->hitcount; i++) {
                hitx = result->hitinfo[i].pos.x;
                hity = result->hitinfo[i].pos.y;
                
                /* vC[ɓRXgグ */
                if (result->hitinfo[i].type == HIT_PLAYER) {
                    maplog_addcost(hitx, hity, 10);
                }
            }
        }
    }
}
