#ifndef __GAME_H__
#define __GAME_H__

//-------------------------------------------------------------------
#ifndef true
#define true (1)
#define false (0)
#endif


//-------------------------------------------------------------------
#define MAGICSEED_FIRE      (0)
#define MAGICSEED_WATER     (1)
#define MAGICSEED_WOOD      (2)
#define MAGICSEED_WIND      (3)
#define MAGICSEED_EARTH     (4)
#define MAGICSEED_LIMIT     (5)

#define MAPSEED_LIMIT       (5)
#define PLAYERSEED_LIMIT    (10)
#define MAPINFO_LIMIT       (10 * 4)

#define MAPATTR_PATH        (0)
#define MAPATTR_WALL        (1)

#define MAP_WIDTH           (20)
#define MAP_HEIGHT          (10)

/* }bv1̗vf */
typedef struct {
    int magicseed[MAPSEED_LIMIT];               /* }bvɂ閂@̗vf     */
    int magicseed_typecount[MAGICSEED_LIMIT];   /* @̗vfƂɉ邩 */
    int seedcount;                              /* @̗vf̐             */
    int mapattr;                                /* ǂ                   */
    int wallcount;                              /* ǂ̑ϋv                 */
} t_mapitem;


//-------------------------------------------------------------------
#define CMD_TURNSKIP    (-1)
#define CMD_MOVE        (0)
#define CMD_MAGIC       (1)
#define CMD_GETSEED     (2)
#define CMD_SEARCH      (3)
#define CMD_LIMIT       (4)

#define MOVE_UP     (0)
#define MOVE_RIGHT  (1)
#define MOVE_DOWN   (2)
#define MOVE_LEFT   (3)
#define MOVE_LIMIT  (4)


//-------------------------------------------------------------------
#define STATE_GAMEINIT      (0)
#define STATE_GAMEINIT_VS   (1)
#define STATE_GAMEPLAY      (2)
#define STATE_GAMEPLAY_VS   (3)
#define STATE_GAMERESULT    (4)
#define STATE_GAMERESULT_VS (5)
#define STATE_GAMERNEXTTURN (6)
#define STATE_GAMEEND       (7)
#define STATE_LIMIT         (8)


//-------------------------------------------------------------------
#define ID_NONPLAYER   (0)
#define ID_PLAYER      (1)
#define ID_VSPLAYER    (2)

#define HIT_NONE        (0)
#define HIT_PLAYER      (1)
#define HIT_WALL        (2)
#define HIT_WALLCRASH   (3)
#define HITINFO_LIMIT   (8+1)


//-------------------------------------------------------------------
/* ʒu */
typedef struct {
    int x, y;           /* ʒu */
} t_pos;

/* vC[Ƃ̏ */
typedef struct {
    t_pos pos;                                  /* vC[̈ʒu           */
    int movearea[MOVE_LIMIT];                   /* ͂œ           */
    int magicseed[PLAYERSEED_LIMIT];            /* Ă閂@̗vf       */
    int magicseed_typecount[MAGICSEED_LIMIT];   /* @̗vfƂɉ邩 */
    int seedcount;                              /* @̗vf̐             */
    int damage;                                 /* _[W                   */
    int shieldcount;                            /* h                       */
    int turn;                                   /* ݂̃^[             */
    int skipturn;                               /* ^[XLbv鐔   */
    int move;                                   /*                        */
} t_playerinfo;

/* ݒ */
typedef struct {
    t_pos pos;          /* ŏ̃vC[̈ʒu */
    char name[256];     /* O                   */
} t_initinfo;

/* s̐ݒ */
typedef struct {
    int type;           /* s̎ */
    int magictype;      /* @̎ */
    int magiccost;      /* @̋K */
    int move;           /*        */
    int count;          /*          */
    t_pos pos;          /* ʒu       */
} t_cmd;

/* }bvT */
typedef struct {
    t_mapitem mapitem;  /* }bv̏             */
    int isplayer;       /* vC[邩ǂ */
    int dir;            /* vC[̕     */
    t_pos pos;          /* ʒu                     */
} t_mapinfo;

/* U */
typedef struct {
    t_pos pos;                          /* ʒu         */
    int type;                           /*  */
} t_hitinfo;

/* ss */
typedef struct {
    int type;                           /* s̎               */
    int magictype;                      /* @̎               */
    int magiccost;                      /* @̋K               */
    int count;                          /*                        */
    int iscmdexec;                      /* ssłǂ */
    t_pos pos;                          /* ʒu                     */
    int move;                           /*                      */
    int hitcount;                       /* ǂ/̐  */
    t_hitinfo hitinfo[HITINFO_LIMIT];   /* ꏊȂǂ̏   */
    t_mapinfo mapinfo[MAPINFO_LIMIT];   /* }bvT     */
} t_result;


//-------------------------------------------------------------------
void wizard_init(t_initinfo *item);
void wizard_turnselect(t_playerinfo *player, t_cmd *cmd, t_mapitem *mapitem);
void wizard_turnresult(t_playerinfo *player, t_result *result);

void vs_wizard_init(t_initinfo *item);
void vs_wizard_turnselect(t_playerinfo *player, t_cmd *cmd, t_mapitem *mapitem);
void vs_wizard_turnresult(t_playerinfo *player, t_result *result);

#endif
