/* -------------------------------------------------------------------
   ASYQ[  WindowspQ[s{  Ver 2.0

                                     2004/8/15
                                         S.Mio
*/

#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include "gamemain.h"
#include "game.h"
#include "mainrc.h"


/* ------------------------------------------------------------------- */
static char szAppName[] = "AlgoGame";
static char szMainClass[] = "AlgoGameClass";
static HINSTANCE hInstance;
static int isgameend = false;
static int gamewaitcount = 0;

#define USERSTATE_NEXT      (STATE_LIMIT + 0)
#define USERSTATE_MOVE      (STATE_LIMIT + 1)
#define USERSTATE_FIRE      (STATE_LIMIT + 2)
#define USERSTATE_WIND      (STATE_LIMIT + 3)
#define USERSTATE_MAGICWIND (STATE_LIMIT + 4)
#define USERSTATE_WATER     (STATE_LIMIT + 5)

#define DRAW_NORMAL       (0)
#define DRAW_MOVE         (1)
#define DRAW_SPELLCASTING (2)


/* ------------------------------------------------------------------- */
/* pX֘A */
char executeDir[_MAX_PATH];
char *resouceDir = "res\\";

/* vO̎spX𓾂 */
char *setExecuteDir(char *srcfilename)
{
    TCHAR drive[_MAX_DRIVE];
    TCHAR dir[_MAX_DIR];
    TCHAR fname[_MAX_FNAME];
    TCHAR ext[_MAX_EXT];
    
    _splitpath(srcfilename, drive, dir, fname, ext);
    sprintf(executeDir, "%s%s", drive, dir);
    return executeDir;
}

/* rbg}bṽpX */
char *makeBitmapPath(char *filename)
{
    static char path[_MAX_PATH];

    sprintf(path, "%s%s%s", executeDir, resouceDir, filename);
    return path;
}


/* ------------------------------------------------------------------- */
/* O */
HWND hEdit;
char buf[1024*64] = "\0";

void makeLogview(HWND hwnd)
{
    RECT rc;
    GetClientRect(hwnd, &rc);
    hEdit = CreateWindow("EDIT", NULL, 
      WS_CHILD | WS_VISIBLE | ES_WANTRETURN | ES_MULTILINE | ES_AUTOVSCROLL | WS_VSCROLL, 
      0, rc.bottom - 100 + 4, rc.right, 100 - 4,
      hwnd, NULL, hInstance, NULL);
    SendMessage(hEdit, EM_SETLIMITTEXT, (WPARAM)1024*64, 0);
}

void printLogview(char *s)
{
    strcat(buf, s);
    SetWindowText(hEdit, buf);
    SendMessage(hEdit, EM_SETSEL, strlen(buf), strlen(buf));
    SendMessage(hEdit, EM_SCROLLCARET, 0, 0);
}

void printlnLogview(char *s)
{
    printLogview(s);
    printLogview("\r\n");
}

void printflnLogview(char *fmt, ...)
{
    va_list args;
    char buf[256];

    va_start(args, fmt);
    vsprintf(buf, fmt, args);
    printlnLogview(buf);
    va_end(args);
}


/* ------------------------------------------------------------------- */
/* `֘A */
#define PARTS_WIDTH   (32)
#define PARTS_HEIGHT  (32)

HBITMAP hBackBitmap;
HBITMAP hMapPartsBitmap;
HBITMAP hMapPartsMask;
HBITMAP hPlayer1Bitmap;
HBITMAP hPlayer1Mask;
HBITMAP hPlayer2Bitmap;
HBITMAP hPlayer2Mask;
HDC hBackDC;

/* rbg}bvt@Cǂݍ */
HBITMAP readBitmap(char *filename)
{
    FILE *fp;
    char *path;
    BITMAPFILEHEADER bmpFileHeader;
    BITMAPINFO *bmpInfo;
    HBITMAP hBitmap;
    BYTE *pixelBits;
    int bmpInfoSize;
    
    path = makeBitmapPath(filename);
    fp = fopen(path, "rb");
    if (fp == NULL)
        return NULL;

    fread(&bmpFileHeader, sizeof(BITMAPFILEHEADER), 1, fp);
    if (bmpFileHeader.bfType != 0x4D42) {
        return NULL;
    }

    bmpInfoSize = bmpFileHeader.bfOffBits - sizeof(BITMAPFILEHEADER);
    bmpInfo = (BITMAPINFO *)malloc(bmpInfoSize);
    fread(bmpInfo, bmpInfoSize, 1, fp);

    hBitmap = CreateDIBSection(
        NULL, bmpInfo, DIB_RGB_COLORS, (void **)&pixelBits, NULL, 0);
    fread(pixelBits, bmpFileHeader.bfSize - bmpFileHeader.bfOffBits, 1, fp);
    fclose(fp);
    return hBitmap;
}

/* }XNf[^̍쐬 */
HBITMAP createMask(HDC hdc, HBITMAP hBitmap)
{
    HBITMAP hMaskBitmap;
    BITMAP bitmap;
    HDC maskDC, bitmapDC;
    int width, height;
    COLORREF colorref;
    
    GetObject(hBitmap, sizeof(BITMAP), &bitmap);
    width  = bitmap.bmWidth;
    height = bitmap.bmHeight;
    DeleteObject(&bitmap);

    maskDC      = CreateCompatibleDC(hdc);
    hMaskBitmap = CreateBitmap(width, height, 1, 1, NULL);
    SelectObject(maskDC, hMaskBitmap);

    bitmapDC    = CreateCompatibleDC(hdc);
    SelectObject(bitmapDC, hBitmap);
    colorref = SetBkColor(bitmapDC, RGB(0xff, 0, 0xff));

    BitBlt(maskDC, 0, 0, width, height, bitmapDC, 0, 0, SRCCOPY);

    SetBkColor(bitmapDC, colorref);
    BitBlt(bitmapDC, 0, 0, width, height, maskDC, 0, 0, 0x00220326);

    DeleteDC(maskDC);
    DeleteDC(bitmapDC);
    return hMaskBitmap;
}

void initGraphic(HDC hdc)
{
    hBackBitmap = CreateCompatibleBitmap(hdc, MAP_WIDTH * PARTS_WIDTH, MAP_HEIGHT * PARTS_HEIGHT);
    hBackDC = CreateCompatibleDC(hdc);

    SelectObject(hBackDC, hBackBitmap);
    PatBlt(hBackDC, 0, 0, MAP_WIDTH * PARTS_WIDTH, MAP_HEIGHT * PARTS_HEIGHT, WHITENESS);
}

void releaseGraphic(void)
{
    DeleteDC(hBackDC);
    DeleteObject(hBackBitmap);
}


/* ------------------------------------------------------------------- */
/* }bv` */
char map_attr[MAP_WIDTH][MAP_HEIGHT];

void mapAttrMake(void)
{
    int x, y;

    for (y = 0; y < MAP_HEIGHT; y++) {
        for (x = 0; x < MAP_WIDTH; x++) {
            if (rand() % 2 == 0) {
                map_attr[x][y] = 1;
            } else {
                map_attr[x][y] = 0;
            }
        }
    }
}

void mapDraw(HDC hdc)
{
    HDC hdcParts;
    t_mapitem *mapitem;
    int x, y, sx, sy;
    
    hdcParts = CreateCompatibleDC(hdc);
    SelectObject(hdcParts, hMapPartsBitmap);
    
    for (y = 0; y < MAP_HEIGHT; y++) {
        for (x = 0; x < MAP_WIDTH; x++) {
            mapitem = game_getmap(x, y);
            sy = 0;
            if (mapitem->seedcount > 0) {
                sx = 0;
            } else {
                sx = PARTS_WIDTH * 3;
            }
            if (mapitem->mapattr == MAPATTR_WALL) {
                sx += PARTS_WIDTH * 2;
            } else if (map_attr[x][y]) {
                sx += PARTS_WIDTH;
            }
            BitBlt(hBackDC, x * PARTS_WIDTH, y * PARTS_WIDTH, 
              PARTS_WIDTH, PARTS_HEIGHT, hdcParts, 
              sx, sy, SRCCOPY);
        }
    }

    DeleteDC(hdcParts);
}


/* ------------------------------------------------------------------- */
/* LN^` */
int dirtable[] = {2, 3, 0, 1};

void drawChara(HDC hdc, int player, int x, int y, int sx, int sy)
{
    HDC hdcParts, hdcPartsMask;
    
    hdcParts = CreateCompatibleDC(hdc);
    hdcPartsMask = CreateCompatibleDC(hdc);

    if (player == ID_PLAYER) {
        SelectObject(hdcParts, hPlayer1Bitmap);
        SelectObject(hdcPartsMask, hPlayer1Mask);
    } else {
        SelectObject(hdcParts, hPlayer2Bitmap);
        SelectObject(hdcPartsMask, hPlayer2Mask);
    }

    BitBlt(hBackDC, x, y, PARTS_WIDTH, PARTS_HEIGHT, 
      hdcPartsMask, sx, sy, SRCAND);
    BitBlt(hBackDC, x, y, PARTS_WIDTH, PARTS_HEIGHT, 
      hdcParts, sx, sy, SRCPAINT);

    DeleteDC(hdcPartsMask);
    DeleteDC(hdcParts);
}

void drawCharaMove(HDC hdc, int player, int x, int y, int movedir, int count)
{
    drawChara(hdc, player, x, y, 
        dirtable[movedir] * PARTS_WIDTH,
        count * PARTS_HEIGHT);
}

void drawCharaCasting(HDC hdc, int player, int x, int y, int count)
{
    drawChara(hdc, player, x, y, 
        MOVE_LIMIT * PARTS_WIDTH, count * PARTS_HEIGHT);
}

/*
void charaDraw(HDC hdc)
{
    HDC hdcParts, hdcPartsMask;
    t_playerinfo *player;
    int sx;
    
    hdcParts = CreateCompatibleDC(hdc);
    SelectObject(hdcParts, hPlayer1Bitmap);
    hdcPartsMask = CreateCompatibleDC(hdc);
    SelectObject(hdcPartsMask, hPlayer1Mask);
    player = game_getuserplayer();
    sx = sxtable[player->move] * PARTS_WIDTH;
    BitBlt(hBackDC, player->pos.x * PARTS_WIDTH, player->pos.y * PARTS_WIDTH, 
      PARTS_WIDTH, PARTS_HEIGHT, 
      hdcPartsMask, 
      sx, 0, SRCAND);
    BitBlt(hBackDC, player->pos.x * PARTS_WIDTH, player->pos.y * PARTS_WIDTH, 
      PARTS_WIDTH, PARTS_HEIGHT, 
      hdcParts, 
      sx, 0, SRCPAINT);

    SelectObject(hdcParts, hPlayer2Bitmap);
    SelectObject(hdcPartsMask, hPlayer2Mask);
    player = game_getvsplayer();
    sx = sxtable[player->move] * PARTS_WIDTH;
    BitBlt(hBackDC, player->pos.x * PARTS_WIDTH, player->pos.y * PARTS_WIDTH, 
      PARTS_WIDTH, PARTS_HEIGHT, 
      hdcPartsMask, 
      sx, 0, SRCAND);
    BitBlt(hBackDC, player->pos.x * PARTS_WIDTH, player->pos.y * PARTS_WIDTH, 
      PARTS_WIDTH, PARTS_HEIGHT, 
      hdcParts, 
      sx, 0, SRCPAINT);

    DeleteDC(hdcPartsMask);
    DeleteDC(hdcParts);
}
*/

/* ------------------------------------------------------------------- */
/* ʂ̕` */

void effectDraw(HDC hdc, int x, int y, int sx, int sy)
{
    HDC hdcParts, hdcPartsMask;

    hdcParts = CreateCompatibleDC(hdc);
    SelectObject(hdcParts, hMapPartsBitmap);
    hdcPartsMask = CreateCompatibleDC(hdc);
    SelectObject(hdcPartsMask, hMapPartsMask);
    
    BitBlt(hBackDC, x, y, PARTS_WIDTH, PARTS_HEIGHT, 
      hdcPartsMask, sx, sy, SRCAND);
    BitBlt(hBackDC, x, y, PARTS_WIDTH, PARTS_HEIGHT, 
      hdcParts, sx, sy, SRCPAINT);

    DeleteDC(hdcPartsMask);
    DeleteDC(hdcParts);
}


void effectFireDraw(HDC hdc, int x, int y, int count)
{
    int sx, sy;
    
    sx = (count % 8) * PARTS_WIDTH;
    sy = 3 * PARTS_HEIGHT;
    
    effectDraw(hdc, x, y, sx, sy);
}

void effectWindDraw(HDC hdc, int x, int y, int count)
{
    int sx, sy;

    sx = (count % 4) * PARTS_WIDTH;
    sy = PARTS_HEIGHT;

    effectDraw(hdc, x, y, sx, sy);
}

void effectWaterDraw(HDC hdc, int x, int y, int count)
{
    int sx, sy;
    
    sx = (4 + (count % 4)) * PARTS_WIDTH;
    sy = PARTS_HEIGHT * 2;
    
    effectDraw(hdc, x, y, sx, sy);
}


/* ------------------------------------------------------------------- */
static char *cmdname[] = {
    "ړ", "@", "@̎𓾂", "͂𒲂ׂ", "x",
};
static char *movename[] = {
    "", "", "", "E", 
};
static char *magicname[] = {
    "", "", "", "", "y",
};

void magicstring(char *buf, t_result *result)
{
    switch(result->magictype) {
      case MAGICSEED_FIRE:
        sprintf(buf, "  %sFu%svōU(%d-%dC:%d) ", 
          cmdname[result->type], 
          magicname[result->magictype],
          result->pos.x,
          result->pos.y,
          result->count);
        break;
      case MAGICSEED_WATER:
        sprintf(buf, "  %sFu%svŉ (񕜓x:%d) ", 
          cmdname[result->type], 
          magicname[result->magictype],
          result->count);
        break;
      case MAGICSEED_WOOD:
        sprintf(buf, "  %sFu%svŖh (x:%d) ", 
          cmdname[result->type], 
          magicname[result->magictype],
          result->count);
        break;
      case MAGICSEED_WIND:
        sprintf(buf, "  %sFu%svŒׂ (%d-%d%dԂ%s) ", 
          cmdname[result->type], 
          magicname[result->magictype],
          result->pos.x,
          result->pos.y,
          result->count,
          movename[result->move]);
        break;
      case MAGICSEED_EARTH:
        sprintf(buf, "  %sFu%svŕǂ쐬 (%d-%dCx:%d) ", 
          cmdname[result->type], 
          magicname[result->magictype],
          result->pos.x,
          result->pos.y,
          result->count);
        break;
    }
}

void seedstring(char *buf, t_playerinfo *playerinfo)
{
    char magicnamebuf[256];
    int i;
    
    strcpy(buf, " ");
    for (i = 0; i < MAGICSEED_LIMIT; i++) {
        sprintf(magicnamebuf, " %s:%d", magicname[i], playerinfo->magicseed_typecount[i]);
        strcat(buf, magicnamebuf);
    }
}

void cmdstring(char *buf, t_result *result)
{
    int count;

    if (result->type == CMD_TURNSKIP) {
        sprintf(buf, "  %s", cmdname[CMD_LIMIT]);
        return;
    }
    if (result->iscmdexec == false) {
        if (result->type == CMD_MAGIC) {
            magicstring(buf, result);
            strcat(buf, "\r\n  s");
        } else {
            sprintf(buf, "  %sFs", 
              cmdname[result->type]);
        }
        return;
    }

    switch(result->type) {
      case CMD_MOVE:
        sprintf(buf, "  %sF%s (%d-%d)", 
          cmdname[result->type], 
          movename[result->move],
          result->pos.x,
          result->pos.y);
        break;
      case CMD_MAGIC:
        magicstring(buf, result);
        break;
      case CMD_GETSEED:
        sprintf(buf, "  %sF%s %d (%d-%d)", 
          cmdname[result->type], 
          magicname[result->magictype],
          result->count,
          result->pos.x,
          result->pos.y);
        break;
      case CMD_SEARCH:
        if (count != 0)
            count = result->count / 4;
        if (count == 0)
            count = 1;
        sprintf(buf, "  %sF%d}XԂ", 
          cmdname[result->type], 
          count);
        break;
    }
}

void printstate(int state)
{
    char buf[1024];

    if (game_isend()) {
        printlnLogview("\r\nQ[II");
        
        if (game_winner() == -1) {
            printlnLogview("");
        } else {
            sprintf(buf, ": %s", game_winnername());
            printlnLogview(buf);
            sprintf(buf, ": %s", game_losername());
            printlnLogview(buf);
        }
        isgameend = true;
        return;
    }

    switch(state) {
      case STATE_GAMEPLAY:
        sprintf(buf, "%s̔", game_playername());
        printlnLogview(buf);
        seedstring(buf, game_getuserplayer());
        printlnLogview(buf);
        break;
      case STATE_GAMERESULT:
        cmdstring(buf, game_getuserplayer_result());
        printlnLogview(buf);
        break;
      case STATE_GAMEPLAY_VS:
        sprintf(buf, "%s̔", game_vsplayername());
        printlnLogview(buf);
        seedstring(buf, game_getvsplayer());
        printlnLogview(buf);
        break;
      case STATE_GAMERESULT_VS:
        cmdstring(buf, game_getvsplayer_result());
        printlnLogview(buf);
        break;
      case STATE_GAMERNEXTTURN:
        sprintf(buf, "\r\n%d^[", game_turncount());
        printlnLogview(buf);
        break;
    }
}


/* ------------------------------------------------------------------- */
/* XvCgIȎdg */
#define SPRITE_LIMIT (32)

typedef struct {
    t_pos pos;
    t_pos endpos;
    int count;
    int movedir;
    int use;
    int cmd;
    int id;
} t_spriteitem;

t_spriteitem playersprite, vsplayersprite;
t_spriteitem effectsprite[SPRITE_LIMIT];
static t_pos difpos[] = {{0, -1}, {1, 0}, {0, 1}, {-1, 0}};

//ړI肩ׂ
int isendSpriteChara(t_spriteitem *spriteitem)
{
    if ((spriteitem->pos.x == spriteitem->endpos.x) &&
        (spriteitem->pos.y == spriteitem->endpos.y)) {
        return true;
    }
    return false;
}

//LN^pXvCg̃JE^i߂
void incSpriteCharaCount(t_spriteitem *spriteitem)
{
    spriteitem->count++;
    if (spriteitem->count >= 4)
        spriteitem->count = 0;
}

//LN^\
void drawSpriteChara(HDC hdc, t_spriteitem *spriteitem)
{
    //rǂ
    if (spriteitem->cmd == DRAW_SPELLCASTING) {
        drawCharaCasting(hdc, spriteitem->id,
            spriteitem->pos.x, spriteitem->pos.y, spriteitem->count);
        
        incSpriteCharaCount(spriteitem);
        return;
    }

    //ړ
    drawCharaMove(hdc, spriteitem->id, spriteitem->pos.x, spriteitem->pos.y, 
      spriteitem->movedir, spriteitem->count);
    
    if (isendSpriteChara(spriteitem)) {
        spriteitem->count = 0;
        return;
    }
    
    //ֈړ
    incSpriteCharaCount(spriteitem);
    spriteitem->pos.x += (difpos[spriteitem->movedir].x) * 2;
    spriteitem->pos.y += (difpos[spriteitem->movedir].y) * 2;
}

void setSpriteChara(int id, int cmd, int movedir, int x, int y, t_spriteitem *spriteitem)
{
    spriteitem->endpos.x = x;
    spriteitem->endpos.y = y;
    spriteitem->count = 0;
    spriteitem->movedir = movedir;
    spriteitem->use = true;
    spriteitem->id = id;
    spriteitem->cmd = cmd;
}

void initSprite(void)
{
    int i;

    for (i = 0; i < SPRITE_LIMIT; i++) {
        effectsprite[i].use = false;
    }
}

t_spriteitem *getNewSprite(void)
{
    int i;

    for (i = 0; i < SPRITE_LIMIT; i++) {
        if (effectsprite[i].use == false)
            return &effectsprite[i];
    }
    return NULL;
}

void deleteSprite(t_spriteitem *spriteitem)
{
    spriteitem->use = false;
}

void setSprite(int id, int cmd, int x, int y, t_spriteitem *spriteitem)
{
    spriteitem->pos.x = x;
    spriteitem->pos.y = y;
    spriteitem->endpos.x = x;
    spriteitem->endpos.y = y;
    spriteitem->count = 0;
    spriteitem->movedir = 0;
    spriteitem->use = true;
    spriteitem->id = id;
    spriteitem->cmd = cmd;
}

void drawSprite(HDC hdc, t_spriteitem *spriteitem)
{
    spriteitem->count++;

    switch (spriteitem->id) {
      case MAGICSEED_FIRE:
        effectFireDraw(hdc, spriteitem->pos.x, spriteitem->pos.y, spriteitem->count);
        break;
      case MAGICSEED_WATER:
        effectWaterDraw(hdc, spriteitem->pos.x, spriteitem->pos.y, spriteitem->count);
        break;
      case MAGICSEED_WIND:
        effectWindDraw(hdc, spriteitem->pos.x, spriteitem->pos.y, spriteitem->count);
        break;
    }
    
    if (spriteitem->count > 10)
        deleteSprite(spriteitem);
}

void drawSpriteAll(HDC hdc)
{
    int i;

    for (i = 0; i < SPRITE_LIMIT; i++) {
        if (effectsprite[i].use == true) {
            drawSprite(hdc, &effectsprite[i]);
        }
    }
}

void deleteSpriteAll(void)
{
    int i;

    for (i = 0; i < SPRITE_LIMIT; i++) {
        deleteSprite(&effectsprite[i]);
    }
}

int isSpriteEmpty(void)
{
    int i;

    for (i = 0; i < SPRITE_LIMIT; i++) {
        if (effectsprite[i].use == true) {
            return false;
        }
    }
    return true;
}


/* ------------------------------------------------------------------- */
/* Q[s֘A */
void gamestart(void)
{
    game_init();
    mapAttrMake();
    initSprite();
    isgameend = false;
}

typedef struct {
    int cmd;
    int state;
} t_stateconvitem;

/* sɉăXe[^Xς */
int stateselectcmd(int state, t_cmd *cmd)
{
    t_stateconvitem stateconvtable[] = {
        {CMD_MOVE,   USERSTATE_MOVE},
        {CMD_SEARCH, USERSTATE_WIND},
        {-1, -1},
    };

    t_stateconvitem magicconvtable[] = {
        {MAGICSEED_FIRE,   USERSTATE_FIRE},
        {MAGICSEED_WATER,  USERSTATE_WATER},
        {MAGICSEED_WIND,   USERSTATE_MAGICWIND},
        {-1, -1},
    };
    
    int i;

    if (cmd->type == CMD_MAGIC) {
        for (i = 0; magicconvtable[i].cmd != -1; i++) {
            if (cmd->magictype == magicconvtable[i].cmd) {
                state = magicconvtable[i].state;
                break;
            }
        }
    } else {
        for (i = 0; stateconvtable[i].cmd != -1; i++) {
            if (cmd->type == stateconvtable[i].cmd) {
                state = stateconvtable[i].state;
                break;
            }
        }
    }
    return state;
}

/* `̎s */
void drawexec(HDC hdc, int state)
{
    mapDraw(hdc);

    if (state > STATE_GAMEINIT_VS) {
        drawSpriteChara(hdc, &playersprite);
        drawSpriteChara(hdc, &vsplayersprite);
    }
    
    drawSpriteAll(hdc);
}

/* Tp\̂߂̃XvCgݒ */
void setwindsprite(int x, int y, int count)
{
    int i, dx, dy, dir;
    t_spriteitem *spriteitem;
    
    for (i = 0; i < count; i++) {
        for (dir = 0; dir < MOVE_LIMIT; dir++) {
            dx = x + (difpos[dir].x * (i + 1));
            dy = y + (difpos[dir].y * (i + 1));
            if (map_isarea(dx, dy) == false)
                continue;
            spriteitem = getNewSprite();
            if (spriteitem != NULL)
                setSprite(MAGICSEED_WIND, 0, dx * PARTS_WIDTH, dy * PARTS_HEIGHT, spriteitem);
        }
    }
}

/* @ɂTp\̂߂̃XvCgݒ */
void setmagicwindsprite(int x, int y, int count, int dir)
{
    int contabl[] = {5, 10};
    int i, dx, dy;
    t_spriteitem *spriteitem;
    
    if (count)
        count--;
    for (i = 0; i < contabl[count]; i++) {
        dx = x + (difpos[dir].x * (i + 1));
        dy = y + (difpos[dir].y * (i + 1));
        if (map_isarea(dx, dy) == false)
            break;
        spriteitem = getNewSprite();
        if (spriteitem != NULL)
            setSprite(MAGICSEED_WIND, 0, dx * PARTS_WIDTH, dy * PARTS_HEIGHT, spriteitem);
    }
}

/* @ɂUp\̂߂̃XvCgݒ */
void setfiresprite(int x, int y, int count)
{
    int i, dx, dy, dir;
    t_spriteitem *spriteitem;
    
    spriteitem = getNewSprite();
    if (spriteitem != NULL)
        setSprite(MAGICSEED_FIRE, 0, x * PARTS_WIDTH, y * PARTS_HEIGHT, spriteitem);
    
    if (count <= 1)
        return;

    for (dir = 0; dir < MOVE_LIMIT; dir++) {
        dx = x + difpos[dir].x;
        dy = y + difpos[dir].y;
        if (map_isarea(dx, dy) == false)
            continue;
        spriteitem = getNewSprite();
        if (spriteitem != NULL)
            setSprite(MAGICSEED_FIRE, 0, dx * PARTS_WIDTH, dy * PARTS_HEIGHT, spriteitem);
    }
}

/* Xe[gɉď */
void stateinit(int id, int state, t_cmd *cmd, t_playerinfo *playerinfo)
{
    int x, y;
    t_spriteitem *spriteitem, *playerspriteitem;

    if (id == ID_PLAYER) {
        playerspriteitem = &playersprite;
    } else {
        playerspriteitem = &vsplayersprite;
    }
    switch (state) {
      case USERSTATE_MOVE:
        x = difpos[cmd->move].x + playerinfo->pos.x;
        y = difpos[cmd->move].y + playerinfo->pos.y;
        setSpriteChara(id, DRAW_MOVE, cmd->move, x * PARTS_WIDTH, y * PARTS_HEIGHT, playerspriteitem);
        break;
      case USERSTATE_FIRE:
        setfiresprite(cmd->pos.x, cmd->pos.y, cmd->magiccost);
        break;
      case USERSTATE_WIND:
        setwindsprite(playerinfo->pos.x, playerinfo->pos.y, cmd->count);
        break;

      case USERSTATE_MAGICWIND:
        setmagicwindsprite(playerinfo->pos.x, playerinfo->pos.y, cmd->magiccost, cmd->move);
        break;

      case USERSTATE_WATER:
        spriteitem = getNewSprite();
        if (spriteitem != NULL)
            setSprite(MAGICSEED_WATER, 0, playerinfo->pos.x * PARTS_WIDTH, playerinfo->pos.y * PARTS_HEIGHT, spriteitem);
        break;
      case USERSTATE_NEXT:
        break;
    }

    if ((state >= USERSTATE_FIRE) && (state <= USERSTATE_WATER)) {
        x = playerinfo->pos.x;
        y = playerinfo->pos.y;
        setSpriteChara(id, DRAW_SPELLCASTING, 0, x * PARTS_WIDTH, y * PARTS_HEIGHT, playerspriteitem);
    }
}

/* ݂̃Xe[^X𑱍s邩ǂ̊mF */
int statecheck(int state)
{
    if (state < USERSTATE_NEXT)
        return state;

    switch (state) {
      case USERSTATE_MOVE:
        gamewaitcount = 0;
        if (isendSpriteChara(&playersprite) && 
            isendSpriteChara(&vsplayersprite))
            return USERSTATE_NEXT;
        break;
      case USERSTATE_FIRE:
      case USERSTATE_WIND:
      case USERSTATE_MAGICWIND:
      case USERSTATE_WATER:
        if (isSpriteEmpty()) {
            if (playersprite.cmd == DRAW_SPELLCASTING) {
                playersprite.movedir = MOVE_DOWN;
                playersprite.cmd = DRAW_MOVE;
                playersprite.count = 0;
            }
            if (vsplayersprite.cmd == DRAW_SPELLCASTING) {
                vsplayersprite.movedir = MOVE_DOWN;
                vsplayersprite.cmd = DRAW_MOVE;
                vsplayersprite.count = 0;
            }
            return USERSTATE_NEXT;
        }
        break;
    }
    return state;
}

/* Xe[^XǗ */
int stateexec(HDC hdc, int state)
{
    int nextstate, x, y;
    t_playerinfo *playerinfo;
    t_result *result;

    if (gamewaitcount != 0) {
        gamewaitcount--;
        return state;
    }

    nextstate = statecheck(state);
    drawexec(hdc, state);

    if (nextstate > USERSTATE_NEXT)
        return state;

    state = game_main();
    printstate(state);
    
    if (state == STATE_GAMEPLAY) {
        result = game_getuserplayer_result();
        if (result->type != CMD_TURNSKIP) {
            state = stateselectcmd(state, game_getuserplayer_cmd());
            stateinit(ID_PLAYER, state, game_getuserplayer_cmd(), game_getuserplayer());
        }
    } else if (state == STATE_GAMEPLAY_VS) {
        result = game_getvsplayer_result();
        if (result->type != CMD_TURNSKIP) {
            state = stateselectcmd(state, game_getvsplayer_cmd());
            stateinit(ID_VSPLAYER, state, game_getvsplayer_cmd(), game_getvsplayer());
        }
    } else {
        if (state == STATE_GAMEINIT_VS) {
            /* LN^pXvCgݒ */
            playerinfo = game_getuserplayer();
            x = playerinfo->pos.x;
            y = playerinfo->pos.y;
            setSpriteChara(ID_PLAYER, DRAW_NORMAL, MOVE_DOWN, x * PARTS_WIDTH, y * PARTS_HEIGHT, &playersprite);
            playersprite.pos.x = playersprite.endpos.x;
            playersprite.pos.y = playersprite.endpos.y;

            playerinfo = game_getvsplayer();
            x = playerinfo->pos.x;
            y = playerinfo->pos.y;
            setSpriteChara(ID_VSPLAYER, DRAW_NORMAL, MOVE_DOWN, x * PARTS_WIDTH, y * PARTS_HEIGHT, &vsplayersprite);
            vsplayersprite.pos.x = vsplayersprite.endpos.x;
            vsplayersprite.pos.y = vsplayersprite.endpos.y;
        }
        if (state > STATE_GAMEINIT_VS)
            gamewaitcount = 10;
    }
    return state;
}


/* ------------------------------------------------------------------- */
/* [v */
DWORD freqcount = 0;

void DoIdle(HWND hwnd)
{
    HDC hdc;
    static int state = 0;

    if (GetTickCount() < freqcount + 50)
        return;
    freqcount = GetTickCount();

    hdc = GetDC(hwnd);

    if (isgameend == false) {
        state = stateexec(hdc, state);
    }

    BitBlt(hdc, 0, 0, MAP_WIDTH * PARTS_WIDTH, MAP_HEIGHT * PARTS_HEIGHT, hBackDC, 0, 0, SRCCOPY);
    ReleaseDC(hwnd, hdc);
}


/* ------------------------------------------------------------------- */
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    HDC hdc;
    PAINTSTRUCT ps;

    switch(msg) {
      case WM_CREATE:
        hdc = GetDC(hwnd);
        initGraphic(hdc);
        makeLogview(hwnd);
        printlnLogview("Q[Jn!\r\n");
        hMapPartsBitmap = readBitmap("map.bmp");
        hPlayer1Bitmap  = readBitmap("man.bmp");
        hPlayer2Bitmap  = readBitmap("girl.bmp");

        hMapPartsMask = createMask(hdc, hMapPartsBitmap);
        hPlayer1Mask = createMask(hdc, hPlayer1Bitmap);
        hPlayer2Mask = createMask(hdc, hPlayer2Bitmap);
        
        ReleaseDC(hwnd, hdc);
        UpdateWindow(hwnd);
        return 0;
      case WM_PAINT:
        hdc = BeginPaint(hwnd, &ps);
        BitBlt(hdc, 0, 0, MAP_WIDTH * PARTS_WIDTH, MAP_HEIGHT * PARTS_HEIGHT, hBackDC, 0, 0, SRCCOPY);
        EndPaint(hwnd, &ps);
        return 0;
      case WM_DESTROY:
        releaseGraphic();
        PostQuitMessage(0);
        return 0;
      case WM_COMMAND:
        switch (LOWORD(wParam)) { 
          case IDM_END:
            SendMessage(hwnd, WM_CLOSE, 0, 0);
            break;
        }
        break; 
    }
    return DefWindowProc(hwnd, msg, wParam, lParam);
}


/* ------------------------------------------------------------------- */
//int APIENTRY __WinMain(HINSTANCE hCurrentInstance, 
int APIENTRY WinMain(HINSTANCE hCurrentInstance, 
  HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow)
{
    HWND hwnd;
    MSG msg;
    WNDCLASS wc;

    setExecuteDir(lpszCmdLine);
    hInstance = hCurrentInstance;

    gamestart();

    if (!hPrevInstance) {
        wc.style            = CS_HREDRAW | CS_VREDRAW; 
        wc.lpfnWndProc      = WndProc;
        wc.cbClsExtra       = 0;
        wc.cbWndExtra       = 0;
        wc.hInstance        = hInstance;
        wc.hIcon            = LoadIcon(hInstance, "IDI_ICON1");
        wc.hCursor          = LoadCursor(NULL, IDC_ARROW);
        wc.hbrBackground    = (HBRUSH)GetStockObject(BLACK_BRUSH);
        wc.lpszMenuName     = "MAINMENU";
        wc.lpszClassName    = szMainClass;
        RegisterClass(&wc);
    }
    hwnd = CreateWindow(
                szMainClass,
                szAppName,
                WS_OVERLAPPEDWINDOW,
                CW_USEDEFAULT,
                CW_USEDEFAULT,
                MAP_WIDTH * PARTS_WIDTH + GetSystemMetrics(SM_CXDLGFRAME) * 2,
                MAP_HEIGHT * PARTS_HEIGHT + 100
                    + GetSystemMetrics(SM_CYCAPTION)
                    + GetSystemMetrics(SM_CYMENU)
                    + GetSystemMetrics(SM_CYDLGFRAME) * 2,
                NULL,
                NULL,
                hInstance,
                NULL);

    ShowWindow(hwnd, nCmdShow);
    UpdateWindow(hwnd);

    //C[v
    for (;;) {
        if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
            if(msg.message == WM_QUIT)
                break;
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        } else {
            DoIdle(hwnd);
        }
    }
    return (int)msg.wParam;
}
